varying vec4 v;
extern vec3 light_position;
extern vec3 object_position;
extern vec4 free_edge;
extern vec4 fixed_edge;

#ifdef VERTEX
vec4 position( mat4 modelviewproj_matrix, vec4 vertex_position )
{

    v = vertex_position;
	vec4 lightPos = vec4(light_position, 0);
	float len = 256;
			
	if (v.x == free_edge[0] && v.y == free_edge[1])
	{
	
		// VaryingColor.rgba = vec4(0.0, 0.0, 0.0, 0.0);
		
		v.x = fixed_edge[0] - lightPos.x/len;
		v.y = fixed_edge[1] - lightPos.y/len;
		
		vec3 delta = vec3(lightPos.xyz - (v.xyz + object_position ));
		float theta = atan(delta.y, delta.x);
		
		// float dist = pow((delta.x*delta.x + delta.y*delta.y), 0.5);
		// len = dist;
		
		v.x -= len * cos(theta);
		v.y -= len * sin(theta);	
	
	}
	
	else if (v.x == free_edge[2] && v.y == free_edge[3])
	{
	
		// VaryingColor.rgba = vec4(0.0, 0.0, 0.0, 0.0);

		v.x = fixed_edge[2] - lightPos.x/len;
		v.y = fixed_edge[3] - lightPos.y/len;
		
		vec3 delta = vec3(lightPos.xyz - (v.xyz + object_position ));
		float theta = atan(delta.y, delta.x);
		
		// float dist = pow((delta.x*delta.x + delta.y*delta.y), 0.5);
		// len = dist;		

		v.x -= len * cos(theta);
		v.y -= len * sin(theta);	
	
	}
    return modelviewproj_matrix * v;
}
#endif


#ifdef PIXEL
vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords )
{
    vec4 texcolor = Texel(texture, texture_coords);
	
    return texcolor * color;
}
#endif